karaf-issues mailing list archives

Site index · List index
Message view « Date » · « Thread »
Top « Date » · « Thread »
From "Volker Althaus (JIRA)" <j...@apache.org>
Subject [jira] [Created] (KARAF-6005) Resolve of bundle with version range in a feature only works with ".m2" and not with "system" directory
Date Wed, 07 Nov 2018 12:04:00 GMT
Volker Althaus created KARAF-6005:
-------------------------------------

             Summary: Resolve of bundle with version range in a feature only works with ".m2"
and not with "system" directory
                 Key: KARAF-6005
                 URL: https://issues.apache.org/jira/browse/KARAF-6005
             Project: Karaf
          Issue Type: Bug
          Components: karaf
    Affects Versions: 4.2.1
            Reporter: Volker Althaus


I defined a feature with a ranged bundle version:

<feature name="some.api" version="1.0.0">
	<bundle>mvn:de.some.api/api/[1,2)</bundle>
</feature>

If a bundle within that range lies within the global/user Maven repo ".m2", the bundle gets
resolved.

If it resides only within the "system" folder of Karaf I get an exception:

{noformat}
karaf@root()> org.apache.karaf.features.internal.util.MultiException: Error:
        Error downloading mvn:de.some.api/api/[1,2)
        at org.apache.karaf.features.internal.download.impl.MavenDownloadManager$MavenDownloader.<init>(MavenDownloadManager.java:91)
        at org.apache.karaf.features.internal.download.impl.MavenDownloadManager.createDownloader(MavenDownloadManager.java:72)
        at org.apache.karaf.features.internal.region.Subsystem.downloadBundles(Subsystem.java:457)
        at org.apache.karaf.features.internal.region.Subsystem.downloadBundles(Subsystem.java:452)
        at org.apache.karaf.features.internal.region.SubsystemResolver.resolve(SubsystemResolver.java:224)
        at org.apache.karaf.features.internal.service.Deployer.deploy(Deployer.java:388)
        at org.apache.karaf.features.internal.service.FeaturesServiceImpl.doProvision(FeaturesServiceImpl.java:1025)
        at org.apache.karaf.features.internal.service.FeaturesServiceImpl.lambda$doProvisionInThread$13(FeaturesServiceImpl.java:964)
        at java.util.concurrent.FutureTask.run(FutureTask.java:266)
        at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)
        at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)
        at java.lang.Thread.run(Thread.java:745)
        Suppressed: java.io.IOException: Error downloading mvn:de.cenit/jaas/[3,4)
                at org.apache.karaf.features.internal.download.impl.AbstractRetryableDownloadTask.run(AbstractRetryableDownloadTask.java:77)
                at java.util.concurrent.Executors$RunnableAdapter.call(Executors.java:511)
                at java.util.concurrent.FutureTask.run(FutureTask.java:266)
                at java.util.concurrent.ScheduledThreadPoolExecutor$ScheduledFutureTask.access$201(ScheduledThreadPoolExecutor.java:180)
                at java.util.concurrent.ScheduledThreadPoolExecutor$ScheduledFutureTask.run(ScheduledThreadPoolExecutor.java:293)
                ... 3 more
        Caused by: java.io.IOException: Error resolving artifact de.some.api:api:[1,2)
                at org.ops4j.pax.url.mvn.internal.AetherBasedResolver.resolve(AetherBasedResolver.java:729)
                at org.ops4j.pax.url.mvn.internal.AetherBasedResolver.resolve(AetherBasedResolver.java:659)
                at org.ops4j.pax.url.mvn.internal.AetherBasedResolver.resolve(AetherBasedResolver.java:600)
                at org.ops4j.pax.url.mvn.internal.AetherBasedResolver.resolve(AetherBasedResolver.java:567)
                at org.apache.karaf.features.internal.download.impl.MavenDownloadTask.download(MavenDownloadTask.java:47)
                at org.apache.karaf.features.internal.download.impl.AbstractRetryableDownloadTask.run(AbstractRetryableDownloadTask.java:60)
                ... 7 more
        Caused by: shaded.org.eclipse.aether.resolution.VersionRangeResolutionException: No
highest version found for de.some.api:api:[1,2)
                at org.ops4j.pax.url.mvn.internal.AetherBasedResolver.resolveLatestVersionRange(AetherBasedResolver.java:998)
                at org.ops4j.pax.url.mvn.internal.AetherBasedResolver.resolve(AetherBasedResolver.java:703)
                ... 12 more
{noformat}

Setting the property org.ops4j.pax.url.mvn.defaultLocalRepoAsRemote = true as mentioned in
the mailing list does not help.




--
This message was sent by Atlassian JIRA
(v7.6.3#76005)

Mime
View raw message